function [ params ] = ReadConfig( configfile )
%Read in a config file for run_experiments. Reads in the parameters and
%stores them in the params object, which will get passed on. Numeric
%parameters are converted to numbers.

% Colin McNally
% 7/3/2014

fid = fopen(configfile,'r');

now_tiling = false;

nextl = fgetl(fid);
while (ischar(nextl))
    if (nextl(1) ~= '%')

        lineel = textscan(nextl,'%s','delimiter','=');
        lineel = lineel{1};
        if ((length(lineel) > 1) && now_tiling)
            now_tiling = false;
        end

        if now_tiling
            linearg = strtrim(lineel{1});
            if (linearg(length(linearg)) == ';')
                linearg = linearg(1:(length(linearg)-1)); %trim off the ';'
            end
        else
            linearg = strtrim(lineel{2});

            if (linearg(length(linearg)) == ';') %start tiling
                now_tiling = true;
                linearg = linearg(1:(length(linearg)-1)); %trim off the ';'
                tiling_variable = strtrim(lineel{1});
                if ~isfield(params,'tiling_variable')
                    params.tiling_variable = {};
                end
                eval(['params.tiling_variable = [ params.tiling_variable, ''' tiling_variable ''' ];']);
                eval(['params.' tiling_variable ' = {}']);
            end

            cur_variable = strtrim(lineel{1});
        end

        lineargs = textscan(linearg,'%s','delimiter',',');
        lineargs = lineargs{1};

        if length(lineargs) == 1
            if (isstrprop(lineargs{1}(1),'digit') || lineargs{1}(1) == '.') %numeric
                midstr = strtrim(lineargs{1});
            else %strings
                midstr = ['''' strtrim(lineargs{1}) ''''];
            end
        else
            if (isstrprop(lineargs{1}(1),'digit') || lineargs{1}(1) == '.') %numeric
                midstr = ['['];
                for j = 1:length(lineargs)
                    midstr = [midstr ' ' strtrim(lineargs{j}) ];
                end
                midstr = [midstr ' ]'];
            else %strings
                midstr = ['{'];
                for j = 1:length(lineargs)
                    midstr = [midstr ' ''' strrep(lineargs{j},' ','') ''''];
                end
                midstr = [midstr '}'];
            end
        end

        if ~now_tiling
            str = ['params.' cur_variable ' = ' midstr ';'];
        else
            str = ['params.' tiling_variable ' = [ params.' tiling_variable ', ' midstr ' ];'];
        end
        eval(str);

    end
    nextl = fgetl(fid);
end
fclose(fid);

filefields = {'input_dir','model_dir','csv_dir','media_csv','dictionary','output_dir','output_filename','starting_condition_file'};
for i = 1:length(filefields)
    if (isfield(params,filefields{i}) && iscell(params.(filefields{i})))
       params.(filefields{i}) =  eval([ 'fullfile(''' strjoin(params.(filefields{i}),''',''') ''')' ]);
    end
end