function [v_sol_minAV_flux ,obj_sol_minAV,status_min_AV,extra] = min_Flux_AV_relaxed(Obj, FBAgrowth, Rxns, Mets, S , Bvector , Lbound , Ubound , CTYPE, VARTYPE);
% This script does not fix the FBA growth, but allow it to vary 1e-7
% This is a old bug that glpk suppose to fix but apparently not in
% minimizing objective. Probably due to the primal-dual transformation

        % ----------------------------------------------------------------

         obj_fluxes = find(Obj ~= 0);
        %(0)ADD THE CONSTRAINT THAT THE MAXIMIZED VALUES FROM PREVIOUS OPTIMIZATION ARE NOW FIXED
% %         new_rows = zeros( length(obj_fluxes) , size(S,2));
% %         constr_rxns = sub2ind( [length(obj_fluxes) size(S,2)] , (1:length(obj_fluxes)) , obj_fluxes' );
% %         new_rows(constr_rxns) = 1;
% %
% %         S = [S ; new_rows];
% %         Bvector = [Bvector ; FBAgrowth];

        %(1)RELAX a little bit the fixed growth rate
        Lbound(obj_fluxes) = FBAgrowth -1e-7;
        Ubound(obj_fluxes) = FBAgrowth +1e-7;

        % ----------------------------------------------------------------



        %ADJUST S MATRIX TO ADD A NEW VARIABLE CORRESPODING TO EACH FLUX, WHICH WILL FUNCTION AS A DISTANCE FROM ZERO
        new_variables = zeros( size(S,1) , size(S,2) );
        S = [S new_variables];

        %NUMBER OF METABOLITES PLUS ADDITIONAL CONSTRAINTS(ROWS OF S, CONSTRAINTS)
        M = size(S,1);

        %NUMBER OF REACTIONS AND ADDITION VARIABLES(COLUMNS OF S, VARIABLES)
        N = size(S,2);

        %ADD TWO NEW CONSTRAINTS FOR EACH FLUX TO ACCOUNT FOR THE CASES OF THE FLUX BEING LESS THAN OR GREATER THAN ZERO
        new_constraints = zeros( size(S,2) , size(S,2) );

        upper_const = 1:2:size(new_constraints,1);
        lower_const = 2:2:size(new_constraints,1);

        fluxes_to_const = 1:(N/2);
        const_vars = fluxes_to_const + (N/2);

        upper_const_flux_i = sub2ind([size(new_constraints,1) size(new_constraints,2)] , upper_const , fluxes_to_const);
        upper_const_var_i = sub2ind([size(new_constraints,1) size(new_constraints,2)] , upper_const , const_vars);
        new_constraints(upper_const_flux_i) = 1;
        new_constraints(upper_const_var_i) = -1;

        lower_const_flux_i = sub2ind([size(new_constraints,1) size(new_constraints,2)] , lower_const , fluxes_to_const);
        lower_const_var_i = sub2ind([size(new_constraints,1) size(new_constraints,2)] , lower_const , const_vars);
        new_constraints(lower_const_flux_i) = -1;
        new_constraints(lower_const_var_i) = -1;

        Bvector = [Bvector ; zeros(size(new_constraints,1),1)];
        S = [S ; new_constraints];

        %SET NEW OBJECTIVE WHICH MINIMIZES THE SUM OF THE NEW VARIABLES REPRESENTING EACH OF THE FLUXES DISTANCE FROM ZERO
        OBJ_min_flux = [zeros( length(Obj) , 1) ; ones( length(Obj) , 1 )];
        Lbound = [Lbound ; zeros( (N/2) , 1)];
        Ubound = [Ubound ; Inf( (N/2) , 1)];

        %MINIMIZE SUM OF ABSOLUTE VALUES OF FLUXES
        min_max = 1;

        %C-TYPE FOR NEW CONSTRAINTS HAS UPPER BOUND
        CTYPE = [ char( 83*ones(1,M) )' ; char( 85*ones( 1,size(new_constraints,1)) )'];

        %VARTYPES STILL ALL CONTINUOUS
        VARTYPE = char( 67*ones(1,size(new_constraints,2)) )';

        param.msglev = 1;
        param.scale = 2;  % default is 1  original(2)
        param.itlim = 10000;
        param.LPsolver = 1; % for glpk
        param.save_pb = 0;  % for glpk

        %PERFORM OPTIMIZATION
        [v_WT_msf ,obj_sol_minAV,status_min_AV,extra] = glpk(OBJ_min_flux , S , Bvector , Lbound , Ubound , CTYPE, VARTYPE , min_max, param);

        n = length(Rxns);
        x = find((v_WT_msf(1:n) - Lbound(1:n)) < -1e-6);

        if (status_min_AV ~= 5 || ~isempty(x))
            param.presol = 0;
            [v_WT_msf ,obj_sol_minAV,status_min_AV,extra] = glpk(OBJ_min_flux , S , Bvector , Lbound , Ubound , CTYPE, VARTYPE , min_max, param);
        end

        v_sol_minAV_flux = v_WT_msf( 1:length(Rxns) );

disp(['                 Relaxed Min_Total_Flux_status = ' num2str(status_min_AV) '   activity =' num2str(sum(abs(v_sol_minAV_flux)))])
disp(['                 Relaxed Growth= ' num2str(v_WT_msf(obj_fluxes)) ])

